---
title: handler.isExtensible()
slug: Web/JavaScript/Reference/Global_Objects/Proxy/Proxy/isExtensible
tags:
  - ECMAScript 2015
  - JavaScript
  - Method
  - Proxy
---
<div>{{JSRef}}</div>

<p>The <strong><code>handler.isExtensible()</code></strong> method is a trap for {{jsxref("Object.isExtensible()")}}.</p>

<div>{{EmbedInteractiveExample("pages/js/proxyhandler-isextensible.html", "taller")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">const <var>p</var> = new Proxy(<var>target</var>, {
  isExtensible: function(<var>target</var>) {
  }
});
</pre>

<h3 id="Parameters">Parameters</h3>

<p>The following parameter is passed to the <code>isExtensible()</code> method. <code>this</code> is bound to the handler.</p>

<dl>
 <dt><code><var>target</var></code></dt>
 <dd>The target object.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>The <code>isExtensible()</code> method must return a boolean value.</p>

<h2 id="Description">Description</h2>

<p>The <code><strong>handler.isExtensible()</strong></code> method is a trap for {{jsxref("Object.isExtensible()")}}.</p>

<h3 id="Interceptions">Interceptions</h3>

<p>This trap can intercept these operations:</p>

<ul>
 <li>{{jsxref("Object.isExtensible()")}}</li>
 <li>{{jsxref("Reflect.isExtensible()")}}</li>
</ul>

<h3 id="Invariants">Invariants</h3>

<p>If the following invariants are violated, the proxy will throw a {{jsxref("TypeError")}}:</p>

<ul>
 <li><code>Object.isExtensible(<var>proxy</var>)</code> must return the same value as <code>Object.isExtensible(<var>target</var>)</code>.</li>
</ul>

<h2 id="Examples">Examples</h2>

<h3 id="Trapping_of_isExtensible">Trapping of isExtensible</h3>

<p>The following code traps {{jsxref("Object.isExtensible()")}}.</p>

<pre class="brush: js notranslate">const p = new Proxy({}, {
  isExtensible: function(target) {
    console.log('called');
    return true;
  }
});

console.log(Object.isExtensible(p)); // "called"
                                     // true
</pre>

<p>The following code violates the invariant.</p>

<pre class="brush: js example-bad notranslate">const p = new Proxy({}, {
  isExtensible: function(target) {
    return false;
  }
});

Object.isExtensible(p); // TypeError is thrown
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-proxy-object-internal-methods-and-internal-slots-isextensible', '[[IsExtensible]]')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.builtins.Proxy.handler.isExtensible")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Proxy")}}</li>
 <li>{{jsxref("Proxy.handler", "handler")}}</li>
 <li>{{jsxref("Object.isExtensible()")}}</li>
 <li>{{jsxref("Reflect.isExtensible()")}}</li>
</ul>
